Skip to main content

Brute Force - Question 1

Recover the Original Array

Alice had a 0-indexed array arr consisting of n positive integers. She chose an arbitrary positive integer k and created two new 0-indexed integer arrays lower and higher in the following manner:

lower[i] = arr[i] - k, for every index i where 0 <= i < n

higher[i] = arr[i] + k, for every index i where 0 <= i < n

Unfortunately, Alice lost all three arrays. However, she remembers the integers that were present in the arrays lower and higher, but not the array each integer belonged to. Help Alice and recover the original array.

Given an array nums consisting of 2n integers, where exactly n of the integers were present in lower and the remaining in higher, return the original array arr. In case the answer is not unique, return any valid array.

Note: The test cases are generated such that there exists at least one valid array arr.


Constraints:


2 * n == nums.length

1 <= n <= 1000

1 <= nums[i] <= 10^9

The test cases are generated such that there exists at least one valid array arr.


Analysis:


This question seems to be very interesting but actually need a brute-force way to solve.

Some observations:

1. the minimum of the array must be from arr[i] - K; similarly, the maximum from arr[i] + K;

2. after sorting the array with size of 2n, the possible ks' can only be the (arr[i] - arr[0])/2, where i can be from 1 to n. Or i cannot be larger than n. 

This is easy to prove: if i can be any value from n+1 to 2*n-1, then we cannot find enough pairs which needs to be n pairs exactly, since the k value becomes too large to make such n pairs.

Or in details: if arr[0] and arr[n+1] is one pair, (one pair here means arr[n+1] - arr[0] == 2*k), then there are not enough arrs on the right-side of arr[n+1] to pair the ones from arr[1] to arr[n].


With the above observations, we can gradually try every possible k.


See the code below:


class Solution {
public:
    vector<int> recoverArray(vector<int>& nums) {
        int n = nums.size();
        sort(nums.begin(), nums.end());
        vector<int> res;
        for(int i=1; i<=n/2; ++i) {
            int k = (nums[i] - nums[0])/2;
            if(k==0) continue;
            vector<int> used(n, 0);
            int j = 0;
            bool find = true;
            while(res.size()<n/2 && j<n) {
                while(j<n&& used[j]) ++j;
                if(j<n) {
                    res.push_back(nums[j]+k);
                    used[j] = 1;
		    // find the first un-used valid element
                    int id = lower_bound(nums.begin(), nums.end(), nums[j]+2*k) - nums.begin();
                    while(id<n&& used[id]) ++id;
		    // if there is no valid element, break and try another k
                    if(id==nums.size() || nums[id] != nums[j]+2*k) {
                        find = false;
                        res.clear();
                        break;
                    }
                    used[id] = 1;
                }
            }
	    // when find one, done
            if(find) break;
        }
        return res;
    }
};



Upper Layer


Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once. We

Binary Search - Hard Level - Question 3

Binary Search - Hard Level - Question 3 878. Nth Magical Number A positive integer is magical if it is divisible by either a or b. Given the three integers n, a, and b, return the nth magical number. Since the answer may be very large, return it modulo 10^9 + 7. Analysis: Let us consider some examples first. Example 1, a = 4, b = 2. If b is dividable by a, then all the numbers which is dividable by a should be dividable by b as well. So the nth magical number should be n*b; Example 2, a = 3, b = 2. The multiples of 2 are: 2, 4, 6, 8, 10, 12, ... The multiple of 3 are: 3, 6, 9, 12, ... So the overlap is related to the minimum common multiple between a and b, and we need to remove the overlap which is double-counted. So now, we make some conclusions: 1. the upper bound of the nth magical number should be n*b, where a is the smaller one (or b <= a); 2. there are n*b/a magical numbers smaller than n*b; 3. there are n*b/(minimum common multiple) overlaps. Thus, the overall count is: n +

Recursion - Example

Recursion - Example Leetcode 231  Power of Two Given an integer n, return true if it is a power of two. Otherwise, return false. An integer n is a power of two, if there exists an integer x such that n == 2^x Constraints: -2^31 <= n <= 2^31 - 1 Analysis: One way is to think about this question recursively: if n%2 == 1, then n must not be power of 2; if not, then we just need to consider whether (n/2) is a power of 2 or not. This is exactly the "same question with a smaller size"! It is trivial to figure out the base cases: if n == 0, return false; if n == 1, return true. See the code below: class Solution { public: bool isPowerOfTwo(int n) { // base cases if(n == 0) return false; if(n == 1) return true; // converging if(n%2 == 1) return false; return isPowerOfTwo(n/2); } }; If interested, there are some other ways to solve this problem. For example, using bit manipulation, we can have the following solution: class